oracle.adf.view.rich.component.rich.data

## Class RichSearchSection

- java.lang.Object
- - javax.faces.component.UIComponent
  - - org.apache.myfaces.trinidad.component.UIXComponent
    - - org.apache.myfaces.trinidad.component.UIXComponentBase
      - - org.apache.myfaces.trinidad.component.UIXObject
        - - oracle.adf.view.rich.component.rich.data.RichSearchSection

- All Implemented Interfaces:
    EventListener, javax.faces.component.PartialStateHolder, javax.faces.component.StateHolder, javax.faces.component.TransientStateHolder, javax.faces.event.ComponentSystemEventListener, javax.faces.event.FacesListener, javax.faces.event.SystemEventListenerHolder

      public class RichSearchSection
      extends org.apache.myfaces.trinidad.component.UIXObject

  The af:searchSection component represents a group of data to be used by the inputSearch component. There are primarily two kinds of searchSection

  - default
  - any other

  The default searchSection should provide a master list of data. Search section of any other type should provide a list that is subset of default searchSection.

  Filtering of data is supported only on default searchSection.

  In the UI, inputSearch component considers two types of view.

  1. Initial view
  2. Filtering view

  In the initial view, data from non-default searchSections and af:suggestionsSection is displayed. In the filtering view, only filtered data from default searchSection will be displayed. If af:suggestionsSection or a non-default searchSection is not provided, only in such a case is data from default searchSection is displayed in the initial view.

  ### Events:

  Type | Phases | Description
  --- | --- | ---
  `org.apache.myfaces.trinidad.event.AttributeChangeEvent` | Invoke Application Apply Request Values | Event delivered to describe an attribute change. Attribute change events are not delivered for any programmatic change to a property. They are only delivered when a renderer changes a property without the application's specific request. An example of an attribute change event might include the width of a column that supported client-side resizing.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.myfaces.trinidad.component.UIXComponentBase

      `org.apache.myfaces.trinidad.component.UIXComponentBase.ComponentSystemEventListenerWrapper`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `COMPONENT_FAMILY`
    `static String` | `COMPONENT_TYPE`
    `static org.apache.myfaces.trinidad.bean.PropertyKey` | `DATA_URL_KEY`
    `static org.apache.myfaces.trinidad.bean.PropertyKey` | `FILTER_KEY`
    `static org.apache.myfaces.trinidad.bean.PropertyKey` | `FILTER_MODE_KEY`
    `static org.apache.myfaces.trinidad.bean.PropertyKey` | `FILTER_PARAMETERS_KEY`
    `static String` | `HEADER_FACET`
    `static org.apache.myfaces.trinidad.bean.PropertyKey` | `PARTIAL_TRIGGERS_KEY`
    `static org.apache.myfaces.trinidad.bean.FacesBean.Type` | `TYPE`
    `static org.apache.myfaces.trinidad.bean.PropertyKey` | `TYPE_KEY`

    - ### Fields inherited from class org.apache.myfaces.trinidad.component.UIXComponentBase

      `BINDING_KEY, ID_KEY, RENDERED_KEY, RENDERER_TYPE_KEY, TRANSIENT_KEY`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `ATTRS_WITH_DECLARED_DEFAULT_VALUES, BEANINFO_KEY, bindings, COMPOSITE_COMPONENT_TYPE_KEY, COMPOSITE_FACET_NAME, CURRENT_COMPONENT, CURRENT_COMPOSITE_COMPONENT, FACETS_KEY, HONOR_CURRENT_COMPONENT_ATTRIBUTES_PARAM_NAME, VIEW_LOCATION_KEY`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `RichSearchSection()` Construct an instance of the RichSearchSection.
    `protected` | `RichSearchSection(String rendererType)` Construct an instance of the RichSearchSection with the specified renderer type.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected org.apache.myfaces.trinidad.bean.FacesBean.Type` | `getBeanType()`
    `String` | `getDataUrl()` Gets REST service endpoint URI that provides a list of suggestions for the search section.
    `String` | `getFamily()`
    `String` | `getFilter()` Gets This attribute holds the name of the JS callback that would perform Array.filter operation on the default searchSection's collection returned from the REST response.
    `String` | `getFilterMode()` Gets The filterMode of the "default" search section.
    `String` | `getFilterParameters()` Gets Attribute to set the query parameters on REST endpoint for filtering of the suggestions on the REST service for a given set of search terms fetching the full row (suggestion) objects from the REST service for a given set of key values
    `javax.faces.component.UIComponent` | `getHeader()` HTML template to be used as per section header.
    `String[]` | `getPartialTriggers()` Gets the IDs of the components that should trigger a partial update.
    `String` | `getType()` Gets The type of the search section.
    `void` | `setDataUrl(String dataUrl)` Sets REST service endpoint URI that provides a list of suggestions for the search section.
    `void` | `setFilter(String filter)` Sets This attribute holds the name of the JS callback that would perform Array.filter operation on the default searchSection's collection returned from the REST response.
    `void` | `setFilterMode(String filterMode)` Sets The filterMode of the "default" search section.
    `void` | `setFilterParameters(String filterParameters)` Sets Attribute to set the query parameters on REST endpoint for filtering of the suggestions on the REST service for a given set of search terms fetching the full row (suggestion) objects from the REST service for a given set of key values
    `void` | `setHeader(javax.faces.component.UIComponent headerFacet)` HTML template to be used as per section header.
    `void` | `setPartialTriggers(String[] partialTriggers)` Sets the IDs of the components that should trigger a partial update.
    `void` | `setType(String type)` Sets The type of the search section.

    - ### Methods inherited from class org.apache.myfaces.trinidad.component.UIXComponentBase

      `adaptMethodBinding, addAttributeChange, addAttributeChangeListener, addClientBehavior, addComponentChange, addComponentChange, addComponentChangeFilter, addFacesListener, broadcast, broadcastToMethodBinding, broadcastToMethodExpression, clearCachedClientIds, clearInitialState, createFacesBean, decode, decodeChildren, decodeChildrenImpl, encodeBegin, encodeChildren, encodeEnd, findComponent, getAttributeChangeListener, getAttributeChangeListeners, getAttributes, getBooleanProperty, getChildCount, getChildren, getClientBehaviors, getClientId, getComponentChangeFilters, getContainerClientId, getDefaultEventName, getFacesBean, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacetNames, getFacets, getFacetsAndChildren, getId, getIntProperty, getLifecycleRenderer, getListenersForEventClass, getParent, getPassThroughAttributes, getProperty, getPropertyKey, getRenderedFacetsAndChildren, getRenderer, getRendererType, getRendersChildren, getValueBinding, getValueExpression, initialStateMarked, invokeOnChildrenComponents, invokeOnComponent, invokeOnNamingContainerComponent, isRendered, isTransient, markInitialState, processDecodes, processRestoreState, processSaveState, processUpdates, processValidators, queueEvent, removeAttributeChangeListener, removeComponentChangeFilter, removeFacesListener, restoreState, satisfiesPartialTrigger, saveState, setAttributeChangeListener, setAttributeChangeListener, setBooleanProperty, setId, setIntProperty, setParent, setProperty, setRendered, setRendererType, setTransient, setupFlattenedChildrenContext, setupFlattenedContext, setValueBinding, setValueExpression, subscribeToEvent, tearDownFlattenedChildrenContext, tearDownFlattenedContext, toString, unsubscribeFromEvent, updateChildren, updateChildrenImpl, validateChildren, validateChildrenImpl`

    - ### Methods inherited from class org.apache.myfaces.trinidad.component.UIXComponent

      `addPartialTarget, broadcastInContext, clearCachedClientIds, defaultGetRenderedFacetsAndChildren, encodeFlattenedChild, encodeFlattenedChildren, getLogicalParent, getLogicalParent, getStateHelper, getStateHelper, isVisitable, partialEncodeVisit, processFlattenedChildren, processFlattenedChildren, processFlattenedChildren, processFlattenedChildren, setPartialTarget, setupChildrenEncodingContext, setupChildrenVisitingContext, setupEncodingContext, setUpEncodingContext, setupVisitingContext, tearDownChildrenEncodingContext, tearDownChildrenVisitingContext, tearDownEncodingContext, tearDownVisitingContext, visitAllChildren, visitChildren, visitChildren, visitTree, visitTree`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getClientId, getCompositeComponentParent, getContainerClientId, getCurrentComponent, getCurrentCompositeComponent, getNamingContainer, getPassThroughAttributes, getResourceBundleMap, getTransientStateHelper, getTransientStateHelper, isCompositeComponent, isInView, popComponentFromEL, processEvent, pushComponentToEL, restoreTransientState, saveTransientState, setInView`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### TYPE

          public static final org.apache.myfaces.trinidad.bean.FacesBean.Type TYPE

    - #### PARTIAL_TRIGGERS_KEY

          public static final org.apache.myfaces.trinidad.bean.PropertyKey PARTIAL_TRIGGERS_KEY

    - #### DATA_URL_KEY

          public static final org.apache.myfaces.trinidad.bean.PropertyKey DATA_URL_KEY

    - #### FILTER_KEY

          public static final org.apache.myfaces.trinidad.bean.PropertyKey FILTER_KEY

    - #### FILTER_PARAMETERS_KEY

          public static final org.apache.myfaces.trinidad.bean.PropertyKey FILTER_PARAMETERS_KEY

    - #### TYPE_KEY

          public static final org.apache.myfaces.trinidad.bean.PropertyKey TYPE_KEY

    - #### FILTER_MODE_KEY

          public static final org.apache.myfaces.trinidad.bean.PropertyKey FILTER_MODE_KEY

    - #### HEADER_FACET

          public static final String HEADER_FACET

      See Also:
        Constant Field Values

    - #### COMPONENT_FAMILY

          public static final String COMPONENT_FAMILY

      See Also:
        Constant Field Values

    - #### COMPONENT_TYPE

          public static final String COMPONENT_TYPE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### RichSearchSection

          public RichSearchSection()

      Construct an instance of the RichSearchSection.

    - #### RichSearchSection

          protected RichSearchSection(String rendererType)

      Construct an instance of the RichSearchSection with the specified renderer type.
      Parameters:
        `rendererType` - the renderer type Construct an instance of the RichSearchSection.

  - ### Method Detail

    - #### getHeader

          public final javax.faces.component.UIComponent getHeader()

      HTML template to be used as per section header. Mustache is the templating system supported by the component. In single selection mode, this facet is applicable only for non-default searchSection. In multi selection mode, the facet on default searchSection will serve the template for the selections list.
      Returns:
        the header facet

    - #### setHeader

          public final void setHeader(javax.faces.component.UIComponent headerFacet)

      HTML template to be used as per section header. Mustache is the templating system supported by the component. In single selection mode, this facet is applicable only for non-default searchSection. In multi selection mode, the facet on default searchSection will serve the template for the selections list.
      Parameters:
        `headerFacet` - the new header facet

    - #### getPartialTriggers

          public final String[] getPartialTriggers()

      Gets the IDs of the components that should trigger a partial update. This component will listen on the trigger components. If one of the trigger components receives an event that will cause it to update in some way, this component will request to be updated too. Identifiers are relative to the source component (this component), and must account for NamingContainers. If your component is already inside of a naming container, you can use a single colon to start the search from the root of the page, or multiple colons to move up through the NamingContainers - "::" will pop out of the component's naming container (or itself if the component is a naming container) and begin the search from there, ":::" will pop out of two naming containers (including itself if the component is a naming container) and begin the search from there, etc.
      Returns:
        the new partialTriggers value

    - #### setPartialTriggers

          public final void setPartialTriggers(String[] partialTriggers)

      Sets the IDs of the components that should trigger a partial update. This component will listen on the trigger components. If one of the trigger components receives an event that will cause it to update in some way, this component will request to be updated too. Identifiers are relative to the source component (this component), and must account for NamingContainers. If your component is already inside of a naming container, you can use a single colon to start the search from the root of the page, or multiple colons to move up through the NamingContainers - "::" will pop out of the component's naming container (or itself if the component is a naming container) and begin the search from there, ":::" will pop out of two naming containers (including itself if the component is a naming container) and begin the search from there, etc.
      Parameters:
        `partialTriggers` - the new partialTriggers value

    - #### getDataUrl

          public final String getDataUrl()

      Gets REST service endpoint URI that provides a list of suggestions for the search section. This attribute supports these various types of URIs:
      - absolute - an absolute path, like "http://samplerest.com/rest/Emp"
      - context relative - a path relatively based on the web application's context root, like "/rest/Emp"
      - server relative - a path relatively based on the web server by application name, like "//RESTWebService-context-root/rest/Emp"

      The REST response should strictly be in JSON format. The component will set the "Accept" header to "application/json" for the REST calls made.

      The JSON document should have a root property labeled "items" and its value should be an array. If "items" property isn't available, the first root property whose value is an array is chosen as the list of suggestions.

      Note: If the REST endpoint is on a different origin, CORS needs to be setup on the endpoint.

      Returns:
        the new dataUrl value

    - #### setDataUrl

          public final void setDataUrl(String dataUrl)

      Sets REST service endpoint URI that provides a list of suggestions for the search section. This attribute supports these various types of URIs:
      - absolute - an absolute path, like "http://samplerest.com/rest/Emp"
      - context relative - a path relatively based on the web application's context root, like "/rest/Emp"
      - server relative - a path relatively based on the web server by application name, like "//RESTWebService-context-root/rest/Emp"

      The REST response should strictly be in JSON format. The component will set the "Accept" header to "application/json" for the REST calls made.

      The JSON document should have a root property labeled "items" and its value should be an array. If "items" property isn't available, the first root property whose value is an array is chosen as the list of suggestions.

      Note: If the REST endpoint is on a different origin, CORS needs to be setup on the endpoint.

      Parameters:
        `dataUrl` - the new dataUrl value

    - #### getFilter

          public final String getFilter()

      Gets This attribute holds the name of the JS callback that would perform Array.filter operation on the default searchSection's collection returned from the REST response. The suggestions filtered by the JS callback will be shown as a separate section in the UI. Such a client filtered suggestion list is equivalent to a non default url provided af:searchSection. This attribute can't be set on the searchSection of type default The component instance will be set as context during JS callback invocation. The row object passed to the callback will have the structure below
      - data: The raw row data
      - index: The index of the row in the collection fetched from the REST call
      - key: The key value for the row
      The index of the row object in the collection that is being filtered is also passed as an parameter to the callback. e.g. Suppose the 24th row data object is as below and the valueAttribute is 'EmpNo'

          {
                     'EmpNo': 1234,
                     'Ename': 'Somename'
                   }

      the object passed to this method will be of format

          {
                     'data': {
                       'EmpNo': 1234,
                       'Ename': 'Somename'
                     },
                     'index': 24,
                     'key': 1234
                   }

      Sample JS method:

          function smartListFiltering(rowObj, rowIndex)
                   {
                     return rowObj.data['isReportee'] == true;
                   }

      Returns:
        the new filter value

    - #### setFilter

          public final void setFilter(String filter)

      Sets This attribute holds the name of the JS callback that would perform Array.filter operation on the default searchSection's collection returned from the REST response. The suggestions filtered by the JS callback will be shown as a separate section in the UI. Such a client filtered suggestion list is equivalent to a non default url provided af:searchSection. This attribute can't be set on the searchSection of type default The component instance will be set as context during JS callback invocation. The row object passed to the callback will have the structure below
      - data: The raw row data
      - index: The index of the row in the collection fetched from the REST call
      - key: The key value for the row
      The index of the row object in the collection that is being filtered is also passed as an parameter to the callback. e.g. Suppose the 24th row data object is as below and the valueAttribute is 'EmpNo'

          {
                     'EmpNo': 1234,
                     'Ename': 'Somename'
                   }

      the object passed to this method will be of format

          {
                     'data': {
                       'EmpNo': 1234,
                       'Ename': 'Somename'
                     },
                     'index': 24,
                     'key': 1234
                   }

      Sample JS method:

          function smartListFiltering(rowObj, rowIndex)
                   {
                     return rowObj.data['isReportee'] == true;
                   }

      Parameters:
        `filter` - the new filter value

    - #### getFilterParameters

          public final String getFilterParameters()

      Gets Attribute to set the query parameters on REST endpoint for
      1. filtering of the suggestions on the REST service for a given set of search terms
      2. fetching the full row (suggestion) objects from the REST service for a given set of key values

      The REST call for fetching the desired resultset is attempted only if the master collection size is beyond the configured fetch limit set on the REST service and the REST response has "hasMore" property set. Otherwise the relevant filtering to obtain the desired resultset is completely done on the client and this attribute is not invoked.

      Note 1: Dependency based filtering should also happen on the server, and it will not be done on the client whenever server filtering is being attempted.

      Note 2: A converter needs to be attached to the inputSearch component to derive the display value from the displayAttributes when the master collection size is beyond the configured fetch limit.

      Note 3: Since searchSection of type default provides the master collection and since only this collection is filterable, this attribute is only applicable for default searchSection.

      This attribute holds the name of the JS callback. This JS callback is invoked when a REST call is being made

      1. in response to user action of filtering.
      2. to fetch the full row objects of the selected values

      The searchSection client component instance will be set as context during JS callback invocation. A request and context objects will be passed as parameters to the function. The callback should return the configured passed in request object.

      The request object will have the structure below:

      - queryString: The string set on this property will be appended as a query parameter to the REST url while making the HTTP request call. If the queryString has a query parameter that is already present in the base url, such a query parameter on the base url will be replaced with the new value in queryString.

        Recommendation: Relevant portions of queryString should be encoded correctly by passing it to encodeURIComponent browser API.

      - method: The request method, e.g., GET, POST. Default is GET
      - body: The request body for POST requests

      The context object will have the structure below:

      - criteria: AdfRichInputSearch.CRITERIA_STARTS_WITH, AdfRichInputSearch.CRITERIA_CONTAINS, AdfRichInputSearch.CRITERIA_ATTRIBUTE_STARTS_WITH or AdfRichInputSearch.CRITERIA_VALUE_EQUALS. Indicates the search that needs to be performed
      - searchTerms: Array of search terms for AdfRichInputSearch.CRITERIA_STARTS_WITH, AdfRichInputSearch.CRITERIA_ATTRIBUTE_STARTS_WITH and AdfRichInputSearch.CRITERIA_CONTAINS. Or array of selected keys or values for which full row object needs to be fetched in case of AdfRichInputSearch.CRITERIA_VALUE_EQUALS
      - filterAttributes: Array of attributes across which the search needs to be filtered. For the case of AdfRichInputSearch.CRITERIA_VALUE_EQUALS, this will have a single value, the valueAttribute of the inputSearch component
      Sample JS method:

          function queryParamProvider(request, context)
                   {
             if (context.criteria == AdfRichInputSearch.CRITERIA_VALUE_EQUALS)
               return selectedQueryParamProvider(request, context);

                     request.queryString = "q=";
                     for (each item in context.filterAttributes)
                       for (each item in context.searchTerms)
                         // append the relevant string to request['queryString'];

                     return request;
           }

           function selectedQueryParamProvider(request, context)
           {
             var values = context.searchTerms;
             var valueAttribute = context.filterAttributes[0];
             var q = "q=";
             for (var i = 0; i < values.length; i++)
             {
               if (i == 0)
                 q += valueAttribute + "=" + values[i];
               else
                 q += " OR " + valueAttribute + "=" + values[i];

             request.queryString = q;
             return request;
                   }

      Returns:
        the new filterParameters value

    - #### setFilterParameters

          public final void setFilterParameters(String filterParameters)

      Sets Attribute to set the query parameters on REST endpoint for
      1. filtering of the suggestions on the REST service for a given set of search terms
      2. fetching the full row (suggestion) objects from the REST service for a given set of key values

      The REST call for fetching the desired resultset is attempted only if the master collection size is beyond the configured fetch limit set on the REST service and the REST response has "hasMore" property set. Otherwise the relevant filtering to obtain the desired resultset is completely done on the client and this attribute is not invoked.

      Note 1: Dependency based filtering should also happen on the server, and it will not be done on the client whenever server filtering is being attempted.

      Note 2: A converter needs to be attached to the inputSearch component to derive the display value from the displayAttributes when the master collection size is beyond the configured fetch limit.

      Note 3: Since searchSection of type default provides the master collection and since only this collection is filterable, this attribute is only applicable for default searchSection.

      This attribute holds the name of the JS callback. This JS callback is invoked when a REST call is being made

      1. in response to user action of filtering.
      2. to fetch the full row objects of the selected values

      The searchSection client component instance will be set as context during JS callback invocation. A request and context objects will be passed as parameters to the function. The callback should return the configured passed in request object.

      The request object will have the structure below:

      - queryString: The string set on this property will be appended as a query parameter to the REST url while making the HTTP request call. If the queryString has a query parameter that is already present in the base url, such a query parameter on the base url will be replaced with the new value in queryString.

        Recommendation: Relevant portions of queryString should be encoded correctly by passing it to encodeURIComponent browser API.

      - method: The request method, e.g., GET, POST. Default is GET
      - body: The request body for POST requests

      The context object will have the structure below:

      - criteria: AdfRichInputSearch.CRITERIA_STARTS_WITH, AdfRichInputSearch.CRITERIA_CONTAINS, AdfRichInputSearch.CRITERIA_ATTRIBUTE_STARTS_WITH or AdfRichInputSearch.CRITERIA_VALUE_EQUALS. Indicates the search that needs to be performed
      - searchTerms: Array of search terms for AdfRichInputSearch.CRITERIA_STARTS_WITH, AdfRichInputSearch.CRITERIA_ATTRIBUTE_STARTS_WITH and AdfRichInputSearch.CRITERIA_CONTAINS. Or array of selected keys or values for which full row object needs to be fetched in case of AdfRichInputSearch.CRITERIA_VALUE_EQUALS
      - filterAttributes: Array of attributes across which the search needs to be filtered. For the case of AdfRichInputSearch.CRITERIA_VALUE_EQUALS, this will have a single value, the valueAttribute of the inputSearch component
      Sample JS method:

          function queryParamProvider(request, context)
                   {
             if (context.criteria == AdfRichInputSearch.CRITERIA_VALUE_EQUALS)
               return selectedQueryParamProvider(request, context);

                     request.queryString = "q=";
                     for (each item in context.filterAttributes)
                       for (each item in context.searchTerms)
                         // append the relevant string to request['queryString'];

                     return request;
           }

           function selectedQueryParamProvider(request, context)
           {
             var values = context.searchTerms;
             var valueAttribute = context.filterAttributes[0];
             var q = "q=";
             for (var i = 0; i < values.length; i++)
             {
               if (i == 0)
                 q += valueAttribute + "=" + values[i];
               else
                 q += " OR " + valueAttribute + "=" + values[i];

             request.queryString = q;
             return request;
                   }

      Parameters:
        `filterParameters` - the new filterParameters value

    - #### getType

          public final String getType()

      Gets The type of the search section. Broadly, there are two types of searchSection that are recognized by af:inputSearch component.
      1. "default": The master suggestions list that the af:inputSearch component will work with. Each inputSearch component must have a default searchSection. The suggestions from default searchSection is displayed only during filtering if af:suggestionsSection or other types of searchSection are also configured.
      2. Other types: A searchSection other than default list is treated as a special suggestion group. Suggestion groups can either have a dataUrl of its own, or can be a client sub-list of default searchSection's data using the filter attribute. In either case, the data of non default searchSection should be a subset of the default searchSection.
      Returns:
        the new type value

    - #### setType

          public final void setType(String type)

      Sets The type of the search section. Broadly, there are two types of searchSection that are recognized by af:inputSearch component.
      1. "default": The master suggestions list that the af:inputSearch component will work with. Each inputSearch component must have a default searchSection. The suggestions from default searchSection is displayed only during filtering if af:suggestionsSection or other types of searchSection are also configured.
      2. Other types: A searchSection other than default list is treated as a special suggestion group. Suggestion groups can either have a dataUrl of its own, or can be a client sub-list of default searchSection's data using the filter attribute. In either case, the data of non default searchSection should be a subset of the default searchSection.
      Parameters:
        `type` - the new type value

    - #### getFilterMode

          public final String getFilterMode()

      Gets The filterMode of the "default" search section. Broadly, there are two types of filterMode that are recognized by af:inputSearch component.
      1. "auto": This is the default filter mode with which best search techniques are used for filtering.
      2. server: Filtering is done on the server side.
      Returns:
        the new filterMode value

    - #### setFilterMode

          public final void setFilterMode(String filterMode)

      Sets The filterMode of the "default" search section. Broadly, there are two types of filterMode that are recognized by af:inputSearch component.
      1. "auto": This is the default filter mode with which best search techniques are used for filtering.
      2. server: Filtering is done on the server side.
      Parameters:
        `filterMode` - the new filterMode value

    - #### getFamily

          public String getFamily()

      Overrides:
        `getFamily` in class `org.apache.myfaces.trinidad.component.UIXObject`

    - #### getBeanType

          protected org.apache.myfaces.trinidad.bean.FacesBean.Type getBeanType()

      Overrides:
        `getBeanType` in class `org.apache.myfaces.trinidad.component.UIXObject`

Copyright (c) 1998, 2018, Oracle and/or its affiliates. All rights reserved.